
        // Get all the recover-slide elements
        const recoverSlides = document.querySelectorAll('.recover-slide');

        // Add event listeners for mouseenter and mouseleave on each recover-slide
        recoverSlides.forEach((slide) => {
            slide.addEventListener('mouseenter', () => {
                // Remove the "active" class from all slides
                recoverSlides.forEach((s) => s.classList.remove('active'));
                
                // Add the "active" class to the current slide
                slide.classList.add('active');
            });

            slide.addEventListener('mouseleave', () => {
                // Remove the "active" class from the current slide when mouse leaves
                slide.classList.remove('active');
            });
        });